(* Title:  BaseDefinitions/example.sml
   Author: Walther Neuper 220731
   (c) due to copyright terms

Isac's example collection belonged to the Java front-end and not to the MathEngine.
But now Isabelle/Isac pulls authoring of examples into Isabelle/PIDE
and re-uses Store.
*)

signature EXAMPLE =
sig
    type description
    type T
    val empty: T

    type id = References_Def.id
    val id_empty: id
    val id_to_string: id -> string

    type store = T Store.node list
    val empty_store: (string * Formalise.T) Store.node
end
                                                                       
(**)
structure Example(** ): EXAMPLE( **) =
struct
(**)

type id = References_Def.id;
val id_empty = "empty-expl-id";
val id_to_string = References_Def.id_to_string;

type description = string;
type T = (description * Formalise.T);
val empty = ("Example.empty description", Formalise.empty);

val empty_store = Store.Node (id_empty, [empty],[]);
type store = (T Store.node) list;

(*
  Introducing 
    fun from_store example_id = Store.get (get_expls ()) example_id example_id;
  (analogous to MethodC.from_store) will require
  separation of this file into "example-def.sml" in BaseDefinitions/
  and "example.sml" somewhere in BridgeJEdit or respektive authoring tools.

  An authoring tool shall also introduce Outer_Syntax.command.
  See http://www.ist.tugraz.at/projects/isac/www/kbase/exp/index_exp.html
*)

(**)end(**)